## Perl-compatible regular expressions

Perl-compatible regular expressions — matches strings against regular expressions

## Functions

gboolean | ( *GRegexEvalCallback ) ()
GRegex * | g_regex_new ()
GRegex * | g_regex_ref ()
void | g_regex_unref ()
const gchar * | g_regex_get_pattern ()
gint | g_regex_get_max_backref ()
gint | g_regex_get_capture_count ()
gboolean | g_regex_get_has_cr_or_lf ()
gint | g_regex_get_max_lookbehind ()
gint | g_regex_get_string_number ()
GRegexCompileFlags | g_regex_get_compile_flags ()
GRegexMatchFlags | g_regex_get_match_flags ()
gchar * | g_regex_escape_string ()
gchar * | g_regex_escape_nul ()
gboolean | g_regex_match_simple ()
gboolean | g_regex_match ()
gboolean | g_regex_match_full ()
gboolean | g_regex_match_all ()
gboolean | g_regex_match_all_full ()
gchar ** | g_regex_split_simple ()
gchar ** | g_regex_split ()
gchar ** | g_regex_split_full ()
gchar * | g_regex_replace ()
gchar * | g_regex_replace_literal ()
gchar * | g_regex_replace_eval ()
gboolean | g_regex_check_replacement ()
GRegex * | g_match_info_get_regex ()
const gchar * | g_match_info_get_string ()
GMatchInfo * | g_match_info_ref ()
void | g_match_info_unref ()
void | g_match_info_free ()
gboolean | g_match_info_matches ()
gboolean | g_match_info_next ()
gint | g_match_info_get_match_count ()
gboolean | g_match_info_is_partial_match ()
gchar * | g_match_info_expand_references ()
gchar * | g_match_info_fetch ()
gboolean | g_match_info_fetch_pos ()
gchar * | g_match_info_fetch_named ()
gboolean | g_match_info_fetch_named_pos ()
gchar ** | g_match_info_fetch_all ()

## Types and Values

enum | GRegexError
#define | G_REGEX_ERROR
enum | GRegexCompileFlags
enum | GRegexMatchFlags
| GRegex
| GMatchInfo

## Includes

    #include <glib.h>

## Description

The g_regex_*() functions implement regular expression pattern matching using syntax and semantics similar to Perl regular expression.

Some functions accept a `start_position` argument, setting it differs from just passing over a shortened string and setting G_REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion. For example, consider the pattern "\Biss\B" which finds occurrences of "iss" in the middle of words. ("\B" matches only if the current position in the subject is not a word boundary.) When applied to the string "Mississipi" from the fourth byte, namely "issipi", it does not match, because "\B" is always false at the start of the subject, which is deemed to be a word boundary. However, if the entire string is passed , but with `start_position` set to 4, it finds the second occurrence of "iss" because it is able to look behind the starting point to discover that it is preceded by a letter.

Note that, unless you set the G_REGEX_RAW flag, all the strings passed to these functions must be encoded in UTF-8. The lengths and the positions inside the strings are in bytes and not in characters, so, for instance, "\xc3\xa0" (i.e. "à") is two bytes long but it is treated as a single character. If you set G_REGEX_RAW the strings can be non-valid UTF-8 strings and a byte is treated as a character, so "\xc3\xa0" is two bytes and two characters long.

When matching a pattern, "\n" matches only against a "\n" character in the string, and "\r" matches only a "\r" character. To match any newline sequence use "\R". This particular group matches either the two-character sequence CR + LF ("\r\n"), or one of the single characters LF (linefeed, U+000A, "\n"), VT vertical tab, U+000B, "\v"), FF (formfeed, U+000C, "\f"), CR (carriage return, U+000D, "\r"), NEL (next line, U+0085), LS (line separator, U+2028), or PS (paragraph separator, U+2029).

The behaviour of the dot, circumflex, and dollar metacharacters are affected by newline characters, the default is to recognize any newline character (the same characters recognized by "\R"). This can be changed with G_REGEX_NEWLINE_CR, G_REGEX_NEWLINE_LF and G_REGEX_NEWLINE_CRLF compile options, and with G_REGEX_MATCH_NEWLINE_ANY, G_REGEX_MATCH_NEWLINE_CR, G_REGEX_MATCH_NEWLINE_LF and G_REGEX_MATCH_NEWLINE_CRLF match options. These settings are also relevant when compiling a pattern if G_REGEX_EXTENDED is set, and an unescaped "#" outside a character class is encountered. This indicates a comment that lasts until after the next newline.

When setting the `G_REGEX_JAVASCRIPT_COMPAT` flag, pattern syntax and pattern matching is changed to be compatible with the way that regular expressions work in JavaScript. More precisely, a lonely ']' character in the pattern is a syntax error; the '\x' escape only allows 0 to 2 hexadecimal digits, and you must use the '\u' escape sequence with 4 hex digits to specify a unicode codepoint instead of '\x' or 'x{....}'. If '\x' or '\u' are not followed by the specified number of hex digits, they match 'x' and 'u' literally; also '\U' always matches 'U' instead of being an error in the pattern. Finally, pattern matching is modified so that back references to an unset subpattern group produces a match with the empty string instead of an error. See pcreapi(3) for more information.

Creating and manipulating the same GRegex structure from different threads is not a problem as GRegex does not modify its internal state between creation and destruction, on the other hand GMatchInfo is not threadsafe.

The regular expressions low-level functionalities are obtained through the excellent PCRE library written by Philip Hazel.

## Functions

### GRegexEvalCallback ()

    gboolean
    (*GRegexEvalCallback) (const GMatchInfo *match_info,
                           GString *result,
                           gpointer user_data);

Specifies the type of the function passed to `g_regex_replace_eval()`. It is called for each occurrence of the pattern in the string passed to `g_regex_replace_eval()`, and it should append the replacement to `result` .

#### Parameters

match_info | the GMatchInfo generated by the match. Use `g_match_info_get_regex()` and `g_match_info_get_string()` if you need the GRegex or the matched string. |
result | a GString containing the new string |
user_data | user data passed to `g_regex_replace_eval()` |

#### Returns

`FALSE` to continue the replacement process, `TRUE` to stop it

Since: 2.14

### g_regex_new ()

    GRegex *
    g_regex_new (const gchar *pattern,
                 GRegexCompileFlags compile_options,
                 GRegexMatchFlags match_options,
                 GError **error);

Compiles the regular expression to an internal form, and does the initial setup of the GRegex structure.

#### Parameters

pattern | the regular expression |
compile_options | compile options for the regular expression, or 0 |
match_options | match options for the regular expression, or 0 |
error | return location for a GError |

#### Returns

a GRegex structure or `NULL` if an error occured. Call `g_regex_unref()` when you are done with it.

[nullable]

Since: 2.14

### g_regex_ref ()

    GRegex *
    g_regex_ref (GRegex *regex);

Increases reference count of `regex` by 1.

#### Parameters

regex | a GRegex |

#### Returns

`regex`

Since: 2.14

### g_regex_unref ()

    void
    g_regex_unref (GRegex *regex);

Decreases reference count of `regex` by 1. When reference count drops to zero, it frees all the memory associated with the regex structure.

#### Parameters

regex | a GRegex |

Since: 2.14

### g_regex_get_pattern ()

    const gchar *
    g_regex_get_pattern (const GRegex *regex);

Gets the pattern string associated with `regex` , i.e. a copy of the string passed to `g_regex_new()`.

#### Parameters

regex | a GRegex structure |

#### Returns

the pattern of `regex`

Since: 2.14

### g_regex_get_max_backref ()

    gint
    g_regex_get_max_backref (const GRegex *regex);

Returns the number of the highest back reference in the pattern, or 0 if the pattern does not contain back references.

#### Parameters

regex | a GRegex |

#### Returns

the number of the highest back reference

Since: 2.14

### g_regex_get_capture_count ()

    gint
    g_regex_get_capture_count (const GRegex *regex);

Returns the number of capturing subpatterns in the pattern.

#### Parameters

regex | a GRegex |

#### Returns

the number of capturing subpatterns

Since: 2.14

### g_regex_get_has_cr_or_lf ()

    gboolean
    g_regex_get_has_cr_or_lf (const GRegex *regex);

Checks whether the pattern contains explicit CR or LF references.

#### Parameters

regex | a GRegex structure |

#### Returns

`TRUE` if the pattern contains explicit CR or LF references

Since: 2.34

### g_regex_get_max_lookbehind ()

    gint
    g_regex_get_max_lookbehind (const GRegex *regex);

Gets the number of characters in the longest lookbehind assertion in the pattern. This information is useful when doing multi-segment matching using the partial matching facilities.

#### Parameters

regex | a GRegex structure |

#### Returns

the number of characters in the longest lookbehind assertion.

Since: 2.38

### g_regex_get_string_number ()

    gint
    g_regex_get_string_number (const GRegex *regex,
                               const gchar *name);

Retrieves the number of the subexpression named `name` .

#### Parameters

regex | GRegex structure |
name | name of the subexpression |

#### Returns

The number of the subexpression or -1 if `name` does not exists

Since: 2.14

### g_regex_get_compile_flags ()

    GRegexCompileFlags
    g_regex_get_compile_flags (const GRegex *regex);

Returns the compile options that `regex` was created with.

Depending on the version of PCRE that is used, this may or may not include flags set by option expressions such as `(?i)` found at the top-level within the compiled pattern.

#### Parameters

regex | a GRegex |

#### Returns

flags from GRegexCompileFlags

Since: 2.26

### g_regex_get_match_flags ()

    GRegexMatchFlags
    g_regex_get_match_flags (const GRegex *regex);

Returns the match options that `regex` was created with.

#### Parameters

regex | a GRegex |

#### Returns

flags from GRegexMatchFlags

Since: 2.26

### g_regex_escape_string ()

    gchar *
    g_regex_escape_string (const gchar *string,
                           gint length);

Escapes the special characters used for regular expressions in `string` , for instance "a.b*c" becomes "a.b*c". This function is useful to dynamically generate regular expressions.

`string` can contain nul characters that are replaced with "\0", in this case remember to specify the correct length of `string` in `length` .

#### Parameters

string | the string to escape. | [array length=length]
length | the length of `string` , or -1 if `string` is nul-terminated |

#### Returns

a newly-allocated escaped string

Since: 2.14

### g_regex_escape_nul ()

    gchar *
    g_regex_escape_nul (const gchar *string,
                        gint length);

Escapes the nul characters in `string` to "\x00". It can be used to compile a regex with embedded nul characters.

For completeness, `length` can be -1 for a nul-terminated string. In this case the output string will be of course equal to `string` .

#### Parameters

string | the string to escape |
length | the length of `string` |

#### Returns

a newly-allocated escaped string

Since: 2.30

### g_regex_match_simple ()

    gboolean
    g_regex_match_simple (const gchar *pattern,
                          const gchar *string,
                          GRegexCompileFlags compile_options,
                          GRegexMatchFlags match_options);

Scans for a match in `string` for `pattern` .

This function is equivalent to `g_regex_match()` but it does not require to compile the pattern with `g_regex_new()`, avoiding some lines of code when you need just to do a match without extracting substrings, capture counts, and so on.

If this function is to be called on the same `pattern` more than once, it's more efficient to compile the pattern once with `g_regex_new()` and then use `g_regex_match()`.

#### Parameters

pattern | the regular expression |
string | the string to scan for matches |
compile_options | compile options for the regular expression, or 0 |
match_options | match options, or 0 |

#### Returns

`TRUE` if the string matched, `FALSE` otherwise

Since: 2.14

### g_regex_match ()

    gboolean
    g_regex_match (const GRegex *regex,
                   const gchar *string,
                   GRegexMatchFlags match_options,
                   GMatchInfo **match_info);

Scans for a match in string for the pattern in `regex` . The `match_options` are combined with the match options specified when the `regex` structure was created, letting you have more flexibility in reusing GRegex structures.

A GMatchInfo structure, used to get information on the match, is stored in `match_info` if not `NULL`. Note that if `match_info` is not `NULL` then it is created even if the function returns `FALSE`, i.e. you must free it regardless if regular expression actually matched.

To retrieve all the non-overlapping matches of the pattern in string you can use `g_match_info_next()`.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19

    static void
    print_uppercase_words (const gchar *string)
    {
      // Print all uppercase-only words.
      GRegex *regex;
      GMatchInfo *match_info;

      regex = g_regex_new ("[A-Z]+", 0, 0, NULL);
      g_regex_match (regex, string, 0, &match_info);
      while (g_match_info_matches (match_info))
        {
          gchar *word = g_match_info_fetch (match_info, 0);
          g_print ("Found: %s\n", word);
          g_free (word);
          g_match_info_next (match_info, NULL);
        }
      g_match_info_free (match_info);
      g_regex_unref (regex);
    }

`string` is not copied and is used in GMatchInfo internally. If you use any GMatchInfo method (except `g_match_info_free()`) after freeing or modifying `string` then the behaviour is undefined.

#### Parameters

regex | a GRegex structure from `g_regex_new()` |
string | the string to scan for matches |
match_options | match options |
match_info | pointer to location where to store the GMatchInfo, or `NULL` if you do not need it. | [out][optional]

#### Returns

`TRUE` is the string matched, `FALSE` otherwise

Since: 2.14

### g_regex_match_full ()

    gboolean
    g_regex_match_full (const GRegex *regex,
                        const gchar *string,
                        gssize string_len,
                        gint start_position,
                        GRegexMatchFlags match_options,
                        GMatchInfo **match_info,
                        GError **error);

Scans for a match in string for the pattern in `regex` . The `match_options` are combined with the match options specified when the `regex` structure was created, letting you have more flexibility in reusing GRegex structures.

Setting `start_position` differs from just passing over a shortened string and setting G_REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\b".

A GMatchInfo structure, used to get information on the match, is stored in `match_info` if not `NULL`. Note that if `match_info` is not `NULL` then it is created even if the function returns `FALSE`, i.e. you must free it regardless if regular expression actually matched.

`string` is not copied and is used in GMatchInfo internally. If you use any GMatchInfo method (except `g_match_info_free()`) after freeing or modifying `string` then the behaviour is undefined.

To retrieve all the non-overlapping matches of the pattern in string you can use `g_match_info_next()`.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25

    static void
    print_uppercase_words (const gchar *string)
    {
      // Print all uppercase-only words.
      GRegex *regex;
      GMatchInfo *match_info;
      GError *error = NULL;

      regex = g_regex_new ("[A-Z]+", 0, 0, NULL);
      g_regex_match_full (regex, string, -1, 0, 0, &match_info, &error);
      while (g_match_info_matches (match_info))
        {
          gchar *word = g_match_info_fetch (match_info, 0);
          g_print ("Found: %s\n", word);
          g_free (word);
          g_match_info_next (match_info, &error);
        }
      g_match_info_free (match_info);
      g_regex_unref (regex);
      if (error != NULL)
        {
          g_printerr ("Error while matching: %s\n", error->message);
          g_error_free (error);
        }
    }

#### Parameters

regex | a GRegex structure from `g_regex_new()` |
string | the string to scan for matches. | [array length=string_len]
string_len | the length of `string` , or -1 if `string` is nul-terminated |
start_position | starting index of the string to match, in bytes |
match_options | match options |
match_info | pointer to location where to store the GMatchInfo, or `NULL` if you do not need it. | [out][optional]
error | location to store the error occurring, or `NULL` to ignore errors |

#### Returns

`TRUE` is the string matched, `FALSE` otherwise

Since: 2.14

### g_regex_match_all ()

    gboolean
    g_regex_match_all (const GRegex *regex,
                       const gchar *string,
                       GRegexMatchFlags match_options,
                       GMatchInfo **match_info);

Using the standard algorithm for regular expression matching only the longest match in the string is retrieved. This function uses a different algorithm so it can retrieve all the possible matches. For more documentation see `g_regex_match_all_full()`.

A GMatchInfo structure, used to get information on the match, is stored in `match_info` if not `NULL`. Note that if `match_info` is not `NULL` then it is created even if the function returns `FALSE`, i.e. you must free it regardless if regular expression actually matched.

`string` is not copied and is used in GMatchInfo internally. If you use any GMatchInfo method (except `g_match_info_free()`) after freeing or modifying `string` then the behaviour is undefined.

#### Parameters

regex | a GRegex structure from `g_regex_new()` |
string | the string to scan for matches |
match_options | match options |
match_info | pointer to location where to store the GMatchInfo, or `NULL` if you do not need it. | [out][optional]

#### Returns

`TRUE` is the string matched, `FALSE` otherwise

Since: 2.14

### g_regex_match_all_full ()

    gboolean
    g_regex_match_all_full (const GRegex *regex,
                            const gchar *string,
                            gssize string_len,
                            gint start_position,
                            GRegexMatchFlags match_options,
                            GMatchInfo **match_info,
                            GError **error);

Using the standard algorithm for regular expression matching only the longest match in the string is retrieved, it is not possible to obtain all the available matches. For instance matching "<a> <b> <c>" against the pattern "<.*>" you get "<a> <b> <c>".

This function uses a different algorithm (called DFA, i.e. deterministic finite automaton), so it can retrieve all the possible matches, all starting at the same point in the string. For instance matching "<a> <b> <c>" against the pattern "<.*>;" you would obtain three matches: "<a> <b> <c>", "<a> <b>" and "<a>".

The number of matched strings is retrieved using `g_match_info_get_match_count()`. To obtain the matched strings and their position you can use, respectively, `g_match_info_fetch()` and `g_match_info_fetch_pos()`. Note that the strings are returned in reverse order of length; that is, the longest matching string is given first.

Note that the DFA algorithm is slower than the standard one and it is not able to capture substrings, so backreferences do not work.

Setting `start_position` differs from just passing over a shortened string and setting G_REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\b".

A GMatchInfo structure, used to get information on the match, is stored in `match_info` if not `NULL`. Note that if `match_info` is not `NULL` then it is created even if the function returns `FALSE`, i.e. you must free it regardless if regular expression actually matched.

`string` is not copied and is used in GMatchInfo internally. If you use any GMatchInfo method (except `g_match_info_free()`) after freeing or modifying `string` then the behaviour is undefined.

#### Parameters

regex | a GRegex structure from `g_regex_new()` |
string | the string to scan for matches. | [array length=string_len]
string_len | the length of `string` , or -1 if `string` is nul-terminated |
start_position | starting index of the string to match, in bytes |
match_options | match options |
match_info | pointer to location where to store the GMatchInfo, or `NULL` if you do not need it. | [out][optional]
error | location to store the error occurring, or `NULL` to ignore errors |

#### Returns

`TRUE` is the string matched, `FALSE` otherwise

Since: 2.14

### g_regex_split_simple ()

    gchar **
    g_regex_split_simple (const gchar *pattern,
                          const gchar *string,
                          GRegexCompileFlags compile_options,
                          GRegexMatchFlags match_options);

Breaks the string on the pattern, and returns an array of the tokens. If the pattern contains capturing parentheses, then the text for each of the substrings will also be returned. If the pattern does not match anywhere in the string, then the whole string is returned as the first token.

This function is equivalent to `g_regex_split()` but it does not require to compile the pattern with `g_regex_new()`, avoiding some lines of code when you need just to do a split without extracting substrings, capture counts, and so on.

If this function is to be called on the same `pattern` more than once, it's more efficient to compile the pattern once with `g_regex_new()` and then use `g_regex_split()`.

As a special case, the result of splitting the empty string "" is an empty vector, not a vector containing a single string. The reason for this special case is that being able to represent a empty vector is typically more useful than consistent handling of empty elements. If you do need to represent empty elements, you'll need to check for the empty string before calling this function.

A pattern that can match empty strings splits `string` into separate characters wherever it matches the empty string between characters. For example splitting "ab c" using as a separator "\s*", you will get "a", "b" and "c".

#### Parameters

pattern | the regular expression |
string | the string to scan for matches |
compile_options | compile options for the regular expression, or 0 |
match_options | match options, or 0 |

#### Returns

a `NULL`-terminated array of strings. Free it using `g_strfreev()`.

[transfer full]

Since: 2.14

### g_regex_split ()

    gchar **
    g_regex_split (const GRegex *regex,
                   const gchar *string,
                   GRegexMatchFlags match_options);

Breaks the string on the pattern, and returns an array of the tokens. If the pattern contains capturing parentheses, then the text for each of the substrings will also be returned. If the pattern does not match anywhere in the string, then the whole string is returned as the first token.

As a special case, the result of splitting the empty string "" is an empty vector, not a vector containing a single string. The reason for this special case is that being able to represent a empty vector is typically more useful than consistent handling of empty elements. If you do need to represent empty elements, you'll need to check for the empty string before calling this function.

A pattern that can match empty strings splits `string` into separate characters wherever it matches the empty string between characters. For example splitting "ab c" using as a separator "\s*", you will get "a", "b" and "c".

#### Parameters

regex | a GRegex structure |
string | the string to split with the pattern |
match_options | match time option flags |

#### Returns

a `NULL`-terminated gchar ** array. Free it using `g_strfreev()`.

[transfer full]

Since: 2.14

### g_regex_split_full ()

    gchar **
    g_regex_split_full (const GRegex *regex,
                        const gchar *string,
                        gssize string_len,
                        gint start_position,
                        GRegexMatchFlags match_options,
                        gint max_tokens,
                        GError **error);

Breaks the string on the pattern, and returns an array of the tokens. If the pattern contains capturing parentheses, then the text for each of the substrings will also be returned. If the pattern does not match anywhere in the string, then the whole string is returned as the first token.

As a special case, the result of splitting the empty string "" is an empty vector, not a vector containing a single string. The reason for this special case is that being able to represent a empty vector is typically more useful than consistent handling of empty elements. If you do need to represent empty elements, you'll need to check for the empty string before calling this function.

A pattern that can match empty strings splits `string` into separate characters wherever it matches the empty string between characters. For example splitting "ab c" using as a separator "\s*", you will get "a", "b" and "c".

Setting `start_position` differs from just passing over a shortened string and setting G_REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\b".

#### Parameters

regex | a GRegex structure |
string | the string to split with the pattern. | [array length=string_len]
string_len | the length of `string` , or -1 if `string` is nul-terminated |
start_position | starting index of the string to match, in bytes |
match_options | match time option flags |
max_tokens | the maximum number of tokens to split `string` into. If this is less than 1, the string is split completely |
error | return location for a GError |

#### Returns

a `NULL`-terminated gchar ** array. Free it using `g_strfreev()`.

[transfer full]

Since: 2.14

### g_regex_replace ()

    gchar *
    g_regex_replace (const GRegex *regex,
                     const gchar *string,
                     gssize string_len,
                     gint start_position,
                     const gchar *replacement,
                     GRegexMatchFlags match_options,
                     GError **error);

Replaces all occurrences of the pattern in `regex` with the replacement text. Backreferences of the form '\number' or '\g<number>' in the replacement text are interpolated by the number-th captured subexpression of the match, '\g<name>' refers to the captured subexpression with the given name. '\0' refers to the complete match, but '\0' followed by a number is the octal representation of a character. To include a literal '\' in the replacement, write '\'.

There are also escapes that changes the case of the following text:

- \l: Convert to lower case the next character

- \u: Convert to upper case the next character

- \L: Convert to lower case till \E

- \U: Convert to upper case till \E

- \E: End case modification

If you do not need to use backreferences use `g_regex_replace_literal()`.

The `replacement` string must be UTF-8 encoded even if G_REGEX_RAW was passed to `g_regex_new()`. If you want to use not UTF-8 encoded stings you can use `g_regex_replace_literal()`.

Setting `start_position` differs from just passing over a shortened string and setting G_REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\b".

#### Parameters

regex | a GRegex structure |
string | the string to perform matches against. | [array length=string_len]
string_len | the length of `string` , or -1 if `string` is nul-terminated |
start_position | starting index of the string to match, in bytes |
replacement | text to replace each match with |
match_options | options for the match |
error | location to store the error occurring, or `NULL` to ignore errors |

#### Returns

a newly allocated string containing the replacements

Since: 2.14

### g_regex_replace_literal ()

    gchar *
    g_regex_replace_literal (const GRegex *regex,
                             const gchar *string,
                             gssize string_len,
                             gint start_position,
                             const gchar *replacement,
                             GRegexMatchFlags match_options,
                             GError **error);

Replaces all occurrences of the pattern in `regex` with the replacement text. `replacement` is replaced literally, to include backreferences use `g_regex_replace()`.

Setting `start_position` differs from just passing over a shortened string and setting G_REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\b".

#### Parameters

regex | a GRegex structure |
string | the string to perform matches against. | [array length=string_len]
string_len | the length of `string` , or -1 if `string` is nul-terminated |
start_position | starting index of the string to match, in bytes |
replacement | text to replace each match with |
match_options | options for the match |
error | location to store the error occurring, or `NULL` to ignore errors |

#### Returns

a newly allocated string containing the replacements

Since: 2.14

### g_regex_replace_eval ()

    gchar *
    g_regex_replace_eval (const GRegex *regex,
                          const gchar *string,
                          gssize string_len,
                          gint start_position,
                          GRegexMatchFlags match_options,
                          GRegexEvalCallback eval,
                          gpointer user_data,
                          GError **error);

Replaces occurrences of the pattern in regex with the output of `eval` for that occurrence.

Setting `start_position` differs from just passing over a shortened string and setting G_REGEX_MATCH_NOTBOL in the case of a pattern that begins with any kind of lookbehind assertion, such as "\b".

The following example uses `g_regex_replace_eval()` to replace multiple strings at once:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34

    static gboolean
    eval_cb (const GMatchInfo *info,
             GString          *res,
             gpointer          data)
    {
      gchar *match;
      gchar *r;

       match = g_match_info_fetch (info, 0);
       r = g_hash_table_lookup ((GHashTable *)data, match);
       g_string_append (res, r);
       g_free (match);

       return FALSE;
    }

    ...

    GRegex *reg;
    GHashTable *h;
    gchar *res;

    h = g_hash_table_new (g_str_hash, g_str_equal);

    g_hash_table_insert (h, "1", "ONE");
    g_hash_table_insert (h, "2", "TWO");
    g_hash_table_insert (h, "3", "THREE");
    g_hash_table_insert (h, "4", "FOUR");

    reg = g_regex_new ("1|2|3|4", 0, 0, NULL);
    res = g_regex_replace_eval (reg, text, -1, 0, 0, eval_cb, h, NULL);
    g_hash_table_destroy (h);

    ...

#### Parameters

regex | a GRegex structure from `g_regex_new()` |
string | string to perform matches against. | [array length=string_len]
string_len | the length of `string` , or -1 if `string` is nul-terminated |
start_position | starting index of the string to match, in bytes |
match_options | options for the match |
eval | a function to call for each match |
user_data | user data to pass to the function |
error | location to store the error occurring, or `NULL` to ignore errors |

#### Returns

a newly allocated string containing the replacements

Since: 2.14

### g_regex_check_replacement ()

    gboolean
    g_regex_check_replacement (const gchar *replacement,
                               gboolean *has_references,
                               GError **error);

Checks whether `replacement` is a valid replacement string (see `g_regex_replace()`), i.e. that all escape sequences in it are valid.

If `has_references` is not `NULL` then `replacement` is checked for pattern references. For instance, replacement text 'foo\n' does not contain references and may be evaluated without information about actual match, but '\0\1' (whole match followed by first subpattern) requires valid GMatchInfo object.

#### Parameters

replacement | the replacement string |
has_references | location to store information about references in `replacement` or `NULL`. | [out][optional]
error | location to store error |

#### Returns

whether `replacement` is a valid replacement string

Since: 2.14

### g_match_info_get_regex ()

    GRegex *
    g_match_info_get_regex (const GMatchInfo *match_info);

Returns GRegex object used in `match_info` . It belongs to Glib and must not be freed. Use `g_regex_ref()` if you need to keep it after you free `match_info` object.

#### Parameters

match_info | a GMatchInfo |

#### Returns

GRegex object used in `match_info`

Since: 2.14

### g_match_info_get_string ()

    const gchar *
    g_match_info_get_string (const GMatchInfo *match_info);

Returns the string searched with `match_info` . This is the string passed to `g_regex_match()` or `g_regex_replace()` so you may not free it before calling this function.

#### Parameters

match_info | a GMatchInfo |

#### Returns

the string searched with `match_info`

Since: 2.14

### g_match_info_ref ()

    GMatchInfo *
    g_match_info_ref (GMatchInfo *match_info);

Increases reference count of `match_info` by 1.

#### Parameters

match_info | a GMatchInfo |

#### Returns

`match_info`

Since: 2.30

### g_match_info_unref ()

    void
    g_match_info_unref (GMatchInfo *match_info);

Decreases reference count of `match_info` by 1. When reference count drops to zero, it frees all the memory associated with the match_info structure.

#### Parameters

match_info | a GMatchInfo |

Since: 2.30

### g_match_info_free ()

    void
    g_match_info_free (GMatchInfo *match_info);

If `match_info` is not `NULL`, calls `g_match_info_unref()`; otherwise does nothing.

#### Parameters

match_info | a GMatchInfo, or `NULL`. | [nullable]

Since: 2.14

### g_match_info_matches ()

    gboolean
    g_match_info_matches (const GMatchInfo *match_info);

Returns whether the previous match operation succeeded.

#### Parameters

match_info | a GMatchInfo structure |

#### Returns

`TRUE` if the previous match operation succeeded, `FALSE` otherwise

Since: 2.14

### g_match_info_next ()

    gboolean
    g_match_info_next (GMatchInfo *match_info,
                       GError **error);

Scans for the next match using the same parameters of the previous call to `g_regex_match_full()` or `g_regex_match()` that returned `match_info` .

The match is done on the string passed to the match function, so you cannot free it before calling this function.

#### Parameters

match_info | a GMatchInfo structure |
error | location to store the error occurring, or `NULL` to ignore errors |

#### Returns

`TRUE` is the string matched, `FALSE` otherwise

Since: 2.14

### g_match_info_get_match_count ()

    gint
    g_match_info_get_match_count (const GMatchInfo *match_info);

Retrieves the number of matched substrings (including substring 0, that is the whole matched text), so 1 is returned if the pattern has no substrings in it and 0 is returned if the match failed.

If the last match was obtained using the DFA algorithm, that is using `g_regex_match_all()` or `g_regex_match_all_full()`, the retrieved count is not that of the number of capturing parentheses but that of the number of matched substrings.

#### Parameters

match_info | a GMatchInfo structure |

#### Returns

Number of matched substrings, or -1 if an error occurred

Since: 2.14

### g_match_info_is_partial_match ()

    gboolean
    g_match_info_is_partial_match (const GMatchInfo *match_info);

Usually if the string passed to g_regex_match*() matches as far as it goes, but is too short to match the entire pattern, `FALSE` is returned. There are circumstances where it might be helpful to distinguish this case from other cases in which there is no match.

Consider, for example, an application where a human is required to type in data for a field with specific formatting requirements. An example might be a date in the form ddmmmyy, defined by the pattern "^\d?\d(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)\d\d$". If the application sees the user’s keystrokes one by one, and can check that what has been typed so far is potentially valid, it is able to raise an error as soon as a mistake is made.

GRegex supports the concept of partial matching by means of the G_REGEX_MATCH_PARTIAL_SOFT and G_REGEX_MATCH_PARTIAL_HARD flags. When they are used, the return code for `g_regex_match()` or `g_regex_match_full()` is, as usual, `TRUE` for a complete match, `FALSE` otherwise. But, when these functions return `FALSE`, you can check if the match was partial calling `g_match_info_is_partial_match()`.

The difference between G_REGEX_MATCH_PARTIAL_SOFT and G_REGEX_MATCH_PARTIAL_HARD is that when a partial match is encountered with G_REGEX_MATCH_PARTIAL_SOFT, matching continues to search for a possible complete match, while with G_REGEX_MATCH_PARTIAL_HARD matching stops at the partial match. When both G_REGEX_MATCH_PARTIAL_SOFT and G_REGEX_MATCH_PARTIAL_HARD are set, the latter takes precedence.

There were formerly some restrictions on the pattern for partial matching. The restrictions no longer apply.

See pcrepartial(3) for more information on partial matching.

#### Parameters

match_info | a GMatchInfo structure |

#### Returns

`TRUE` if the match was partial, `FALSE` otherwise

Since: 2.14

### g_match_info_expand_references ()

    gchar *
    g_match_info_expand_references (const GMatchInfo *match_info,
                                    const gchar *string_to_expand,
                                    GError **error);

Returns a new string containing the text in `string_to_expand` with references and escape sequences expanded. References refer to the last match done with `string` against `regex` and have the same syntax used by `g_regex_replace()`.

The `string_to_expand` must be UTF-8 encoded even if G_REGEX_RAW was passed to `g_regex_new()`.

The backreferences are extracted from the string passed to the match function, so you cannot call this function after freeing the string.

`match_info` may be `NULL` in which case `string_to_expand` must not contain references. For instance "foo\n" does not refer to an actual pattern and '\n' merely will be replaced with \n character, while to expand "\0" (whole match) one needs the result of a match. Use `g_regex_check_replacement()` to find out whether `string_to_expand` contains references.

#### Parameters

match_info | a GMatchInfo or `NULL`. | [nullable]
string_to_expand | the string to expand |
error | location to store the error occurring, or `NULL` to ignore errors |

#### Returns

the expanded string, or `NULL` if an error occurred.

[nullable]

Since: 2.14

### g_match_info_fetch ()

    gchar *
    g_match_info_fetch (const GMatchInfo *match_info,
                        gint match_num);

Retrieves the text matching the `match_num` 'th capturing parentheses. 0 is the full text of the match, 1 is the first paren set, 2 the second, and so on.

If `match_num` is a valid sub pattern but it didn't match anything (e.g. sub pattern 1, matching "b" against "(a)?b") then an empty string is returned.

If the match was obtained using the DFA algorithm, that is using `g_regex_match_all()` or `g_regex_match_all_full()`, the retrieved string is not that of a set of parentheses but that of a matched substring. Substrings are matched in reverse order of length, so 0 is the longest match.

The string is fetched from the string passed to the match function, so you cannot call this function after freeing the string.

#### Parameters

match_info | GMatchInfo structure |
match_num | number of the sub expression |

#### Returns

The matched substring, or `NULL` if an error occurred. You have to free the string yourself.

[nullable]

Since: 2.14

### g_match_info_fetch_pos ()

    gboolean
    g_match_info_fetch_pos (const GMatchInfo *match_info,
                            gint match_num,
                            gint *start_pos,
                            gint *end_pos);

Retrieves the position in bytes of the `match_num` 'th capturing parentheses. 0 is the full text of the match, 1 is the first paren set, 2 the second, and so on.

If `match_num` is a valid sub pattern but it didn't match anything (e.g. sub pattern 1, matching "b" against "(a)?b") then `start_pos` and `end_pos` are set to -1 and `TRUE` is returned.

If the match was obtained using the DFA algorithm, that is using `g_regex_match_all()` or `g_regex_match_all_full()`, the retrieved position is not that of a set of parentheses but that of a matched substring. Substrings are matched in reverse order of length, so 0 is the longest match.

#### Parameters

match_info | GMatchInfo structure |
match_num | number of the sub expression |
start_pos | pointer to location where to store the start position, or `NULL`. | [out][optional]
end_pos | pointer to location where to store the end position, or `NULL`. | [out][optional]

#### Returns

`TRUE` if the position was fetched, `FALSE` otherwise. If the position cannot be fetched, `start_pos` and `end_pos` are left unchanged

Since: 2.14

### g_match_info_fetch_named ()

    gchar *
    g_match_info_fetch_named (const GMatchInfo *match_info,
                              const gchar *name);

Retrieves the text matching the capturing parentheses named `name` .

If `name` is a valid sub pattern name but it didn't match anything (e.g. sub pattern "X", matching "b" against "(?P<X>a)?b") then an empty string is returned.

The string is fetched from the string passed to the match function, so you cannot call this function after freeing the string.

#### Parameters

match_info | GMatchInfo structure |
name | name of the subexpression |

#### Returns

The matched substring, or `NULL` if an error occurred. You have to free the string yourself.

[nullable]

Since: 2.14

### g_match_info_fetch_named_pos ()

    gboolean
    g_match_info_fetch_named_pos (const GMatchInfo *match_info,
                                  const gchar *name,
                                  gint *start_pos,
                                  gint *end_pos);

Retrieves the position in bytes of the capturing parentheses named `name` .

If `name` is a valid sub pattern name but it didn't match anything (e.g. sub pattern "X", matching "b" against "(?P<X>a)?b") then `start_pos` and `end_pos` are set to -1 and `TRUE` is returned.

#### Parameters

match_info | GMatchInfo structure |
name | name of the subexpression |
start_pos | pointer to location where to store the start position, or `NULL`. | [out][optional]
end_pos | pointer to location where to store the end position, or `NULL`. | [out][optional]

#### Returns

`TRUE` if the position was fetched, `FALSE` otherwise. If the position cannot be fetched, `start_pos` and `end_pos` are left unchanged.

Since: 2.14

### g_match_info_fetch_all ()

    gchar **
    g_match_info_fetch_all (const GMatchInfo *match_info);

Bundles up pointers to each of the matching substrings from a match and stores them in an array of gchar pointers. The first element in the returned array is the match number 0, i.e. the entire matched text.

If a sub pattern didn't match anything (e.g. sub pattern 1, matching "b" against "(a)?b") then an empty string is inserted.

If the last match was obtained using the DFA algorithm, that is using `g_regex_match_all()` or `g_regex_match_all_full()`, the retrieved strings are not that matched by sets of parentheses but that of the matched substring. Substrings are matched in reverse order of length, so the first one is the longest match.

The strings are fetched from the string passed to the match function, so you cannot call this function after freeing the string.

#### Parameters

match_info | a GMatchInfo structure |

#### Returns

a `NULL`-terminated array of gchar * pointers. It must be freed using `g_strfreev()`. If the previous match failed `NULL` is returned.

[transfer full]

Since: 2.14

## Types and Values

### enum GRegexError

Error codes returned by regular expressions functions.

#### Members

G_REGEX_ERROR_COMPILE | Compilation of the regular expression failed. |
G_REGEX_ERROR_OPTIMIZE | Optimization of the regular expression failed. |
G_REGEX_ERROR_REPLACE | Replacement failed due to an ill-formed replacement string. |
G_REGEX_ERROR_MATCH | The match process failed. |
G_REGEX_ERROR_INTERNAL | Internal error of the regular expression engine. Since 2.16 |
G_REGEX_ERROR_STRAY_BACKSLASH | "\" at end of pattern. Since 2.16 |
G_REGEX_ERROR_MISSING_CONTROL_CHAR | "\c" at end of pattern. Since 2.16 |
G_REGEX_ERROR_UNRECOGNIZED_ESCAPE | Unrecognized character follows "\". Since 2.16 |
G_REGEX_ERROR_QUANTIFIERS_OUT_OF_ORDER | Numbers out of order in "{}" quantifier. Since 2.16 |
G_REGEX_ERROR_QUANTIFIER_TOO_BIG | Number too big in "{}" quantifier. Since 2.16 |
G_REGEX_ERROR_UNTERMINATED_CHARACTER_CLASS | Missing terminating "]" for character class. Since 2.16 |
G_REGEX_ERROR_INVALID_ESCAPE_IN_CHARACTER_CLASS | Invalid escape sequence in character class. Since 2.16 |
G_REGEX_ERROR_RANGE_OUT_OF_ORDER | Range out of order in character class. Since 2.16 |
G_REGEX_ERROR_NOTHING_TO_REPEAT | Nothing to repeat. Since 2.16 |
G_REGEX_ERROR_UNRECOGNIZED_CHARACTER | Unrecognized character after "(?", "(?<" or "(?P". Since 2.16 |
G_REGEX_ERROR_POSIX_NAMED_CLASS_OUTSIDE_CLASS | POSIX named classes are supported only within a class. Since 2.16 |
G_REGEX_ERROR_UNMATCHED_PARENTHESIS | Missing terminating ")" or ")" without opening "(". Since 2.16 |
G_REGEX_ERROR_INEXISTENT_SUBPATTERN_REFERENCE | Reference to non-existent subpattern. Since 2.16 |
G_REGEX_ERROR_UNTERMINATED_COMMENT | Missing terminating ")" after comment. Since 2.16 |
G_REGEX_ERROR_EXPRESSION_TOO_LARGE | Regular expression too large. Since 2.16 |
G_REGEX_ERROR_MEMORY_ERROR | Failed to get memory. Since 2.16 |
G_REGEX_ERROR_VARIABLE_LENGTH_LOOKBEHIND | Lookbehind assertion is not fixed length. Since 2.16 |
G_REGEX_ERROR_MALFORMED_CONDITION | Malformed number or name after "(?(". Since 2.16 |
G_REGEX_ERROR_TOO_MANY_CONDITIONAL_BRANCHES | Conditional group contains more than two branches. Since 2.16 |
G_REGEX_ERROR_ASSERTION_EXPECTED | Assertion expected after "(?(". Since 2.16 |
G_REGEX_ERROR_UNKNOWN_POSIX_CLASS_NAME | Unknown POSIX class name. Since 2.16 |
G_REGEX_ERROR_POSIX_COLLATING_ELEMENTS_NOT_SUPPORTED | POSIX collating elements are not supported. Since 2.16 |
G_REGEX_ERROR_HEX_CODE_TOO_LARGE | Character value in "\x{...}" sequence is too large. Since 2.16 |
G_REGEX_ERROR_INVALID_CONDITION | Invalid condition "(?(0)". Since 2.16 |
G_REGEX_ERROR_SINGLE_BYTE_MATCH_IN_LOOKBEHIND | \C not allowed in lookbehind assertion. Since 2.16 |
G_REGEX_ERROR_INFINITE_LOOP | Recursive call could loop indefinitely. Since 2.16 |
G_REGEX_ERROR_MISSING_SUBPATTERN_NAME_TERMINATOR | Missing terminator in subpattern name. Since 2.16 |
G_REGEX_ERROR_DUPLICATE_SUBPATTERN_NAME | Two named subpatterns have the same name. Since 2.16 |
G_REGEX_ERROR_MALFORMED_PROPERTY | Malformed "\P" or "\p" sequence. Since 2.16 |
G_REGEX_ERROR_UNKNOWN_PROPERTY | Unknown property name after "\P" or "\p". Since 2.16 |
G_REGEX_ERROR_SUBPATTERN_NAME_TOO_LONG | Subpattern name is too long (maximum 32 characters). Since 2.16 |
G_REGEX_ERROR_TOO_MANY_SUBPATTERNS | Too many named subpatterns (maximum 10,000). Since 2.16 |
G_REGEX_ERROR_INVALID_OCTAL_VALUE | Octal value is greater than "\377". Since 2.16 |
G_REGEX_ERROR_TOO_MANY_BRANCHES_IN_DEFINE | "DEFINE" group contains more than one branch. Since 2.16 |
G_REGEX_ERROR_DEFINE_REPETION | Repeating a "DEFINE" group is not allowed. This error is never raised. Since: 2.16 Deprecated: 2.34 |
G_REGEX_ERROR_INCONSISTENT_NEWLINE_OPTIONS | Inconsistent newline options. Since 2.16 |
G_REGEX_ERROR_MISSING_BACK_REFERENCE | "\g" is not followed by a braced, angle-bracketed, or quoted name or number, or by a plain number. Since: 2.16 |
G_REGEX_ERROR_INVALID_RELATIVE_REFERENCE | relative reference must not be zero. Since: 2.34 |
G_REGEX_ERROR_BACKTRACKING_CONTROL_VERB_ARGUMENT_FORBIDDEN | the backtracing control verb used does not allow an argument. Since: 2.34 |
G_REGEX_ERROR_UNKNOWN_BACKTRACKING_CONTROL_VERB | unknown backtracing control verb. Since: 2.34 |
G_REGEX_ERROR_NUMBER_TOO_BIG | number is too big in escape sequence. Since: 2.34 |
G_REGEX_ERROR_MISSING_SUBPATTERN_NAME | Missing subpattern name. Since: 2.34 |
G_REGEX_ERROR_MISSING_DIGIT | Missing digit. Since 2.34 |
G_REGEX_ERROR_INVALID_DATA_CHARACTER | In JavaScript compatibility mode, "[" is an invalid data character. Since: 2.34 |
G_REGEX_ERROR_EXTRA_SUBPATTERN_NAME | different names for subpatterns of the same number are not allowed. Since: 2.34 |
G_REGEX_ERROR_BACKTRACKING_CONTROL_VERB_ARGUMENT_REQUIRED | the backtracing control verb requires an argument. Since: 2.34 |
G_REGEX_ERROR_INVALID_CONTROL_CHAR | "\c" must be followed by an ASCII character. Since: 2.34 |
G_REGEX_ERROR_MISSING_NAME | "\k" is not followed by a braced, angle-bracketed, or quoted name. Since: 2.34 |
G_REGEX_ERROR_NOT_SUPPORTED_IN_CLASS | "\N" is not supported in a class. Since: 2.34 |
G_REGEX_ERROR_TOO_MANY_FORWARD_REFERENCES | too many forward references. Since: 2.34 |
G_REGEX_ERROR_NAME_TOO_LONG | the name is too long in "(*MARK)", "(*PRUNE)", "(*SKIP)", or "(*THEN)". Since: 2.34 |
G_REGEX_ERROR_CHARACTER_VALUE_TOO_LARGE | the character value in the \u sequence is too large. Since: 2.34 |

Since: 2.14

### G_REGEX_ERROR

    #define G_REGEX_ERROR g_regex_error_quark ()

Error domain for regular expressions. Errors in this domain will be from the GRegexError enumeration. See GError for information on error domains.

Since: 2.14

### enum GRegexCompileFlags

Flags specifying compile-time options.

#### Members

G_REGEX_CASELESS | Letters in the pattern match both upper- and lowercase letters. This option can be changed within a pattern by a "(?i)" option setting. |

G_REGEX_MULTILINE

By default, GRegex treats the strings as consisting of a single line of characters (even if it actually contains newlines). The "start of line" metacharacter ("^") matches only at the start of the string, while the "end of line" metacharacter ("$") matches only at the end of the string, or before a terminating newline (unless G_REGEX_DOLLAR_ENDONLY is set). When G_REGEX_MULTILINE is set, the "start of line" and "end of line" constructs match immediately following or immediately before any newline in the string, respectively, as well as at the very start and end. This can be changed within a pattern by a "(?m)" option setting.

G_REGEX_DOTALL | A dot metacharater (".") in the pattern matches all characters, including newlines. Without it, newlines are excluded. This option can be changed within a pattern by a ("?s") option setting. |
G_REGEX_EXTENDED | Whitespace data characters in the pattern are totally ignored except when escaped or inside a character class. Whitespace does not include the VT character (code 11). In addition, characters between an unescaped "#" outside a character class and the next newline character, inclusive, are also ignored. This can be changed within a pattern by a "(?x)" option setting. |
G_REGEX_ANCHORED | The pattern is forced to be "anchored", that is, it is constrained to match only at the first matching point in the string that is being searched. This effect can also be achieved by appropriate constructs in the pattern itself such as the "^" metacharater. |
G_REGEX_DOLLAR_ENDONLY | A dollar metacharacter ("$") in the pattern matches only at the end of the string. Without this option, a dollar also matches immediately before the final character if it is a newline (but not before any other newlines). This option is ignored if G_REGEX_MULTILINE is set. |
G_REGEX_UNGREEDY | Inverts the "greediness" of the quantifiers so that they are not greedy by default, but become greedy if followed by "?". It can also be set by a "(?U)" option setting within the pattern. |
G_REGEX_RAW | Usually strings must be valid UTF-8 strings, using this flag they are considered as a raw sequence of bytes. |
G_REGEX_NO_AUTO_CAPTURE | Disables the use of numbered capturing parentheses in the pattern. Any opening parenthesis that is not followed by "?" behaves as if it were followed by "?:" but named parentheses can still be used for capturing (and they acquire numbers in the usual way). |
G_REGEX_OPTIMIZE | Optimize the regular expression. If the pattern will be used many times, then it may be worth the effort to optimize it to improve the speed of matches. |
G_REGEX_FIRSTLINE | Limits an unanchored pattern to match before (or at) the first newline. Since: 2.34 |
G_REGEX_DUPNAMES | Names used to identify capturing subpatterns need not be unique. This can be helpful for certain types of pattern when it is known that only one instance of the named subpattern can ever be matched. |
G_REGEX_NEWLINE_CR | Usually any newline character or character sequence is recognized. If this option is set, the only recognized newline character is '\r'. |
G_REGEX_NEWLINE_LF | Usually any newline character or character sequence is recognized. If this option is set, the only recognized newline character is '\n'. |
G_REGEX_NEWLINE_CRLF | Usually any newline character or character sequence is recognized. If this option is set, the only recognized newline character sequence is '\r\n'. |
G_REGEX_NEWLINE_ANYCRLF | Usually any newline character or character sequence is recognized. If this option is set, the only recognized newline character sequences are '\r', '\n', and '\r\n'. Since: 2.34 |
G_REGEX_BSR_ANYCRLF | Usually any newline character or character sequence is recognised. If this option is set, then "\R" only recognizes the newline characters '\r', '\n' and '\r\n'. Since: 2.34 |
G_REGEX_JAVASCRIPT_COMPAT | Changes behaviour so that it is compatible with JavaScript rather than PCRE. Since: 2.34 |

Since: 2.14

### enum GRegexMatchFlags

Flags specifying match-time options.

#### Members

G_REGEX_MATCH_ANCHORED | The pattern is forced to be "anchored", that is, it is constrained to match only at the first matching point in the string that is being searched. This effect can also be achieved by appropriate constructs in the pattern itself such as the "^" metacharater. |
G_REGEX_MATCH_NOTBOL | Specifies that first character of the string is not the beginning of a line, so the circumflex metacharacter should not match before it. Setting this without G_REGEX_MULTILINE (at compile time) causes circumflex never to match. This option affects only the behaviour of the circumflex metacharacter, it does not affect "\A". |
G_REGEX_MATCH_NOTEOL | Specifies that the end of the subject string is not the end of a line, so the dollar metacharacter should not match it nor (except in multiline mode) a newline immediately before it. Setting this without G_REGEX_MULTILINE (at compile time) causes dollar never to match. This option affects only the behaviour of the dollar metacharacter, it does not affect "\Z" or "\z". |

G_REGEX_MATCH_NOTEMPTY

An empty string is not considered to be a valid match if this option is set. If there are alternatives in the pattern, they are tried. If all the alternatives match the empty string, the entire match fails. For example, if the pattern "a?b?" is applied to a string not beginning with "a" or "b", it matches the empty string at the start of the string. With this flag set, this match is not valid, so GRegex searches further into the string for occurrences of "a" or "b".

G_REGEX_MATCH_PARTIAL | Turns on the partial matching feature, for more documentation on partial matching see `g_match_info_is_partial_match()`. |
G_REGEX_MATCH_NEWLINE_CR | Overrides the newline definition set when creating a new GRegex, setting the '\r' character as line terminator. |
G_REGEX_MATCH_NEWLINE_LF | Overrides the newline definition set when creating a new GRegex, setting the '\n' character as line terminator. |
G_REGEX_MATCH_NEWLINE_CRLF | Overrides the newline definition set when creating a new GRegex, setting the '\r\n' characters sequence as line terminator. |
G_REGEX_MATCH_NEWLINE_ANY | Overrides the newline definition set when creating a new GRegex, any Unicode newline sequence is recognised as a newline. These are '\r', '\n' and '\rn', and the single characters U+000B LINE TABULATION, U+000C FORM FEED (FF), U+0085 NEXT LINE (NEL), U+2028 LINE SEPARATOR and U+2029 PARAGRAPH SEPARATOR. |
G_REGEX_MATCH_NEWLINE_ANYCRLF | Overrides the newline definition set when creating a new GRegex; any '\r', '\n', or '\r\n' character sequence is recognized as a newline. Since: 2.34 |
G_REGEX_MATCH_BSR_ANYCRLF | Overrides the newline definition for "\R" set when creating a new GRegex; only '\r', '\n', or '\r\n' character sequences are recognized as a newline by "\R". Since: 2.34 |
G_REGEX_MATCH_BSR_ANY | Overrides the newline definition for "\R" set when creating a new GRegex; any Unicode newline character or character sequence are recognized as a newline by "\R". These are '\r', '\n' and '\rn', and the single characters U+000B LINE TABULATION, U+000C FORM FEED (FF), U+0085 NEXT LINE (NEL), U+2028 LINE SEPARATOR and U+2029 PARAGRAPH SEPARATOR. Since: 2.34 |
G_REGEX_MATCH_PARTIAL_SOFT | An alias for G_REGEX_MATCH_PARTIAL. Since: 2.34 |
G_REGEX_MATCH_PARTIAL_HARD | Turns on the partial matching feature. In contrast to to G_REGEX_MATCH_PARTIAL_SOFT, this stops matching as soon as a partial match is found, without continuing to search for a possible complete match. See `g_match_info_is_partial_match()` for more information. Since: 2.34 |
G_REGEX_MATCH_NOTEMPTY_ATSTART | Like G_REGEX_MATCH_NOTEMPTY, but only applied to the start of the matched string. For anchored patterns this can only happen for pattern containing "\K". Since: 2.34 |

Since: 2.14

### GRegex

    typedef struct _GRegex GRegex;

A GRegex is the "compiled" form of a regular expression pattern. This structure is opaque and its fields cannot be accessed directly.

Since: 2.14

### GMatchInfo

    typedef struct _GMatchInfo GMatchInfo;

A GMatchInfo is an opaque struct used to return information about matches.

## See Also

Regular expression syntax